package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Collection;
import java.util.List;
import org.antlr.analysis.DFAState;
import org.antlr.analysis.DecisionProbe;
import org.antlr.analysis.Label;
import org.antlr.analysis.NFAState;
import org.antlr.tool.GrammarAST;
import org.antlr.tool.Message;
import org.stringtemplate.v4.ST;

public class RecursionOverflowMessage extends Message {
  public DecisionProbe probe;
  
  public DFAState sampleBadState;
  
  public int alt;
  
  public Collection<String> targetRules;
  
  public Collection<? extends Collection<? extends NFAState>> callSiteStates;
  
  public RecursionOverflowMessage(DecisionProbe probe, DFAState sampleBadState, int alt, Collection<String> targetRules, Collection<? extends Collection<? extends NFAState>> callSiteStates) {
    super(206);
    this.probe = probe;
    this.sampleBadState = sampleBadState;
    this.alt = alt;
    this.targetRules = targetRules;
    this.callSiteStates = callSiteStates;
  }
  
  public String toString() {
    GrammarAST decisionASTNode = this.probe.dfa.getDecisionASTNode();
    this.line = decisionASTNode.getLine();
    this.column = decisionASTNode.getCharPositionInLine();
    String fileName = this.probe.dfa.nfa.grammar.getFileName();
    if (fileName != null)
      this.file = fileName; 
    ST st = getMessageTemplate();
    st.add("targetRules", this.targetRules);
    st.add("alt", Integer.valueOf(this.alt));
    st.add("callSiteStates", this.callSiteStates);
    List<Label> labels = this.probe.getSampleNonDeterministicInputSequence(this.sampleBadState);
    String input = this.probe.getInputSequenceDisplay(labels);
    st.add("input", input);
    return toString(st);
  }
}
